; C:USEDOS  -  Uses the DOS  "DIR"  command to create a catalog of files with
; similar extensions. It requires "DIR", "TYPE", and "EDIT" to be included in
; ACAD.PGP.   Any  editor  can  be  attached  to  the EDIT call, but DIR must
; represent the actual DOS "DIR" command, for example:
;
;                       DEL,DEL,       33000,File to delete: ,0
;                       DIR,DIR,       33000,File specification: ,0
;                       EDIT,MYEDITOR, 48000,File to edit: ,0
;                       SH,,           33000,*OS Command: ,0
;                       SHELL,,       127000,*OS Command: ,0
;                       TYPE,TYPE,     33000,File to list: ,0
;------------------------------------------------------------------------------
(defun CNT-LINES (HFN / NH CUR-LINE);HoldFileName
   (setq NH (open HFN "r")
         CNT 0
         CUR-LINE "")
   (while (not (= CUR-LINE nil))
          (progn
             (setq CUR-LINE (read-line NH))
             (setq CNT (1+ CNT))))
   (close NH)
);CNT-LINES
;------------------------------------------------------------------------------
(defun DO-COM ( PN EXT CN COM / CNT LEN DOSEXT FILE-TOO HDG)
                              ;PathName, EXTension,CatalogName,COMmand
  (repeat 25 (print))(textscr)
  (princ (strcat "\nPlease wait...building catalog " EXT))(print)
  (setq LEN 1
        CNT 0
        HDG (strcat (chr 32) EXT (chr 32))
        DOSEXT (strcat (chr 32) (substr EXT 3 3) (chr 32))
        FILE-TOO "")
   (WRITE-DIR (strcat PN EXT) CN DOSEXT)
   (setq PEEK (open CN "r"))
   (if (/= (read-line PEEK) nil)
       (progn
         (apply '(lambda (TXT-LOC)
                 (repeat 50
                   (progn (grtext TXT-LOC "        ")
                   (setq TXT-LOC (1+ TXT-LOC))))) '(0))
         (POP-SCRN HDG "********" CN 2 "mc")
         (if (/= CANCEL? "YES")
           (progn
             (repeat 8
               (progn
                  (if (/= (substr HLDFILE LEN 1) (chr 32))
                      (setq FILE-TOO (strcat FILE-TOO (substr HLDFILE LEN 1))
                            LEN (1+ LEN)))))
            (if (= COM "LOAD")
                (setq LOADFLAG "YES"
                      RUNFILE (strcat PN FILE-TOO ".LSP"))
                (command COM (strcat PN FILE-TOO (substr EXT 2)))))))
       (progn
         (graphscr)(print)
         (princ "\n\t\t< Illegal path or no Matching Files >" )(print)
         (getstring "\npress any key to continue...")))
);DO-COM
;------------------------------------------------------------------------------
(defun PICK-FILE ( / PT1)
  (repeat 5 (print))
  (prompt "\nSelect File : ")
  (setq PT1 (grread)
        SEL-LOC (car PT1)
        FILE-SEL (cadr PT1))
  (cond 
     ((/= SEL-LOC 4) (PICK-FILE))
     ((and (= CUR-PG NUM-PGS) (= FILE-SEL 19)) (setq MORE? "NO"
                                                     CANCEL? "YES"))
     ((and (= CUR-PG NUM-PGS) (or (> FILE-SEL (1+ CH-LST))
                                  (= FILE-SEL 0)
                                  (= FILE-SEL 1))) (PICK-FILE))
     ((or (= FILE-SEL 0)  (= FILE-SEL 1) (> FILE-SEL 19)) (PICK-FILE))
     ((and (= SEL-LOC 4)  (= FILE-SEL 19)) (setq MORE? "YES"))
     ((and (= SEL-LOC 4)  (/= FILE-SEL 19)) (setq MORE? "NO"))
     (t)
  );cond
);PICK-FILE
;------------------------------------------------------------------------------
(defun POP-SCRN (HDG L2 FN SN NH / CTR CNT TXT-LOC SN NH)
                ; HeaDinG, Line2, FileName, StartNumber, NameHolder
   (setq CNT 0 TXT-LOC 0)
   (CNT-LINES FN)
   (repeat 19
     (progn (grtext TXT-LOC "        ")
            (setq TXT-LOC (1+ TXT-LOC))))
   (if (> CNT 17)
       (progn
           (grtext TXT-LOC "* Next *")
           (setq TXT-LOC (1+ TXT-LOC))))
   (repeat 10 (progn
                 (grtext TXT-LOC "        ")
                 (setq TXT-LOC (1+ TXT-LOC))))
   (grtext 0 HDG)
   (grtext 1 L2)
   (setq NH (open FN "r")
         CH-LST 0
         CTR SN
         NUM-PGS (fix (+ 1 (/ CNT 17.00)))
         TXT-LOC SN
         OLD-PGS 0
         CUR-PG 1
         CH-REM (1- CNT)
         CUR-MEM 1
         MORE? "yes"
         CANCEL? "NO"
         HLDFILE nil)
   (if (> CH-REM 17)
       (setq CH-PG 17)
       (setq CH-LST CH-PG
             CH-PG CH-REM))
   (while (/= MORE? "NO")
      (progn
         (print HLDFILE)
         (if (= CUR-PG NUM-PGS)
             (progn
                (setq CH-LST CH-REM
                      TXT-LOC SN)
                (repeat 17
                   (progn
                      (grtext TXT-LOC "        ")
                      (setq TXT-LOC (1+ TXT-LOC))))
                      (grtext TXT-LOC " Return ")))
         (setq TXT-LOC SN)
         (repeat CH-PG
            (progn
               (grtext TXT-LOC (read-line NH))
               (setq TXT-LOC (1+ TXT-LOC)
                     CH-REM (1- CH-REM)
                     CUR-MEM (1+ CUR-MEM)))
            (if (> CH-REM 17)
                (setq CH-PG 17)
                (setq CH-PG CH-REM)))
         (PICK-FILE)
         (setq OLD-PGS (1+ OLD-PGS)
               CUR-PG (1+ CUR-PG))))
   (close NH)
   (if (/= CANCEL? "YES")
       (progn
         (setq NH (open FN "r"))
         (repeat (+ (* 17 (* (1- OLD-PGS))) (- FILE-SEL 2))
                 (print (read-line NH)))
         (setq HLDFILE (read-line NH))
         (close NH)
         (print HLDFILE)))
);POP-SCRN
;------------------------------------------------------------------------------
(defun SEL-OPT (IG PS DF OL / HOLD);InitGet, PromptString,DeFault, OptionLine
   (initget IG)
   (repeat 24 (print))(princ PS)(print)(princ "\n")
   (setq OPTION DF
         HOLD OPTION
         OPTION (getkword (strcat OL OPTION ">: ")))
   (if (null OPTION)
       (setq OPTION HOLD))(repeat 5 (print))(prin1)
);SEL-OPT
;------------------------------------------------------------------------------
(defun WRITE-DIR ( PN CAT-FILE EXT / NH CUR-LINE CNT)
                                   ;Path Name, CATalogFile, Extension 
   (setq DIR-FILE (strcat PN ">HOLD.DIR"))
   (command "DIR" DIR-FILE)
        (CNT-LINES "HOLD.DIR")
        (setq NH (open "HOLD.DIR" "r")
              CAT-FILE (open CAT-FILE "w"))
   (repeat (1- CNT)
           (progn 
             (setq CUR-LINE (read-line NH))
              (if (= (substr CUR-LINE 9 5) (strcase EXT))
                  (write-line (substr CUR-LINE 1 12) CAT-FILE))))
   (close NH)(close CAT-FILE)(prin1)
;   (command "DEL" "HOLD.DIR")
);WRITE-DIR
;---------------------------------- Main Program ------------------------------
(defun C:USEDOS ()
   (graphscr)(repeat 5 (print))
   (setq HOLDERR *error*
         LOADFLAG "NO"
         DEF-PATH (getvar "DWGPREFIX")
         PATHNAME (getstring (strcat "\nPath to search <" DEF-PATH "> : ")))
   (if (= PATHNAME "") (setq PATHNAME DEF-PATH))
   (setq NAMELEN (strlen PATHNAME))
   (if (/= (substr PATHNAME NAMELEN) "\\")
           (setq PATHNAME (strcat PATHNAME "\\")))

 Rudimentary Error Trap
   (defun *error* (MSG)
     (repeat 5 (print))
     (setq *error* HOLDERR)
     (princ (strcat "\t" MSG ".....  <RETURN> to run again" ))
     (print)(grtext)(prin1))

  (SEL-OPT "Block Lisp Slide X" "\nSelect file TYPE... " "Lisp"
           "Block/Lisp/Slide/eXit<")
  (cond ((= OPTION "Block")
            (DO-COM PATHNAME "*.dwg" "BLOCKS.CAT" "INSERT"))
        ((= OPTION "Lisp")
          (progn
            (SEL-OPT "Browse Edit Load" "\nSelect TASK... " "Load"
                     "Browse/Edit/Load<"))
            (cond
              ((= OPTION "Browse")(DO-COM PATHNAME "*.lsp" "LISP.CAT" "TYPE"))

; You can replace "TYPE" in the above line with the call to your favorite
; file browser, for example:
;                   (DO-COM PATHNAME "*.lsp" "LISP.CAT" "Browse")
; The browser you use must be attached to ACAD.PGP, for example:
;                 Browse,C:\UTIL\BROWSE,    33000,File to Browse: ,0

              ((= OPTION "Edit")  (DO-COM PATHNAME "*.lsp" "LISP.CAT" "Edit"))
              ((= OPTION "Load")  (DO-COM PATHNAME "*.lsp" "LISP.CAT" "LOAD"))
            );cond
          );progn
        ((= OPTION "Slide") (DO-COM PATHNAME "*.sld" "SLIDE.CAT" "VSLIDE"))
        (t))
   (grtext)
   (setq *error* HOLDERR)
   (repeat 5 (print))
   (if (= LOADFLAG "YES")
       (progn (princ (strcat "\nLoading <" RUNFILE ">\n"))(load RUNFILE))
       (prin1))
);USEDOS
